Object Storage API, REST: Bucket.Update
- HTTP request
- Path parameters
- Body parameters
- AnonymousAccessFlags
- CorsRule
- WebsiteSettings
- Scheme
- RoutingRule
- Condition
- Redirect
- LifecycleRule
- RuleFilter
- Tag
- And
- Expiration
- Transition
- AfterDays
- NoncurrentExpiration
- NoncurrentTransition
- NoncurrentDeleteMarkers
- ACL
- Grant
- ObjectLock
- DefaultRetention
- Encryption
- EncryptionRule
- BucketAllowedPrivateEndpoints
- Response
- Status
Updates the specified bucket.
In most cases, storage.editor role (see documentation) should be enough
to update a bucket, subject to its policy.
HTTP request
PATCH https://storage.api.yandexcloud.kz/storage/v1/buckets/{name}
Path parameters
|
Field |
Description |
|
name |
string Required field. Name of the bucket to update. |
Body parameters
{
"updateMask": "string",
"anonymousAccessFlags": {
"read": "boolean",
"list": "boolean",
"configRead": "boolean"
},
"defaultStorageClass": "string",
"maxSize": "string",
"cors": [
{
"id": "string",
"allowedMethods": [
"string"
],
"allowedHeaders": [
"string"
],
"allowedOrigins": [
"string"
],
"exposeHeaders": [
"string"
],
"maxAgeSeconds": "string"
}
],
"websiteSettings": {
"index": "string",
"error": "string",
"redirectAllRequests": {
"protocol": "string",
"hostname": "string"
},
"routingRules": [
{
"condition": {
"httpErrorCodeReturnedEquals": "string",
"keyPrefixEquals": "string"
},
"redirect": {
"hostname": "string",
"httpRedirectCode": "string",
"protocol": "string",
"replaceKeyPrefixWith": "string",
"replaceKeyWith": "string"
}
}
]
},
"versioning": "string",
"lifecycleRules": [
{
"id": "string",
"enabled": "boolean",
"filter": {
"prefix": "string",
"objectSizeGreaterThan": "string",
"objectSizeLessThan": "string",
"tag": {
"key": "string",
"value": "string"
},
"andOperator": {
"prefix": "string",
"objectSizeGreaterThan": "string",
"objectSizeLessThan": "string",
"tag": [
{
"key": "string",
"value": "string"
}
]
}
},
"expiration": {
"date": "string",
"days": "string",
"expiredObjectDeleteMarker": "boolean"
},
"transitions": [
{
"date": "string",
"days": "string",
"storageClass": "string"
}
],
"abortIncompleteMultipartUpload": {
"daysAfterExpiration": "string"
},
"noncurrentExpiration": {
"noncurrentDays": "string"
},
"noncurrentTransitions": [
{
"noncurrentDays": "string",
"storageClass": "string"
}
],
"noncurrentDeleteMarkers": {
"noncurrentDays": "string"
}
}
],
"policy": "object",
"acl": {
"grants": [
{
"permission": "string",
"grantType": "string",
"granteeId": "string"
}
]
},
"tags": [
{
"key": "string",
"value": "string"
}
],
"objectLock": {
"status": "string",
"defaultRetention": {
// Includes only one of the fields `days`, `years`
"days": "string",
"years": "string",
// end of the list of possible fields
"mode": "string"
}
},
"encryption": {
"rules": [
{
"kmsMasterKeyId": "string",
"sseAlgorithm": "string"
}
]
},
"allowedPrivateEndpoints": {
"enabled": "boolean",
"privateEndpoints": [
"string"
],
"forceCloudConsoleAccess": "boolean"
},
"disabledStatickeyAuth": "boolean"
}
|
Field |
Description |
|
updateMask |
string (field-mask) Required field. A comma-separated names off ALL fields to be updated. If |
|
anonymousAccessFlags |
Flags for configuring public (anonymous) access to the bucket's content and settings. |
|
defaultStorageClass |
string Default storage class for objects in the bucket. Supported classes are standard storage ( |
|
maxSize |
string (int64) Maximum size of the bucket, in bytes. |
|
cors[] |
List of rules for cross-domain requests to objects in the bucket (cross-origin resource sharing, CORS). |
|
websiteSettings |
Configuration for hosting a static website in the bucket. |
|
versioning |
enum (Versioning) Bucket versioning status.
|
|
lifecycleRules[] |
List of object lifecycle rules for the bucket. |
|
policy |
object Bucket policies that set permissions for actions with the bucket, its objects, and groups of objects. |
|
acl |
Access control list (ACL) of the bucket. |
|
tags[] |
List of tags for the bucket. |
|
objectLock |
Configuration for object lock on the bucket. |
|
encryption |
Configuration for bucket's encryption. |
|
allowedPrivateEndpoints |
requires permission s3:PutBucketAllowedPrivateEndpoints |
|
disabledStatickeyAuth |
boolean An option to disable static key auth for a bucket. |
AnonymousAccessFlags
|
Field |
Description |
|
read |
boolean Specifies whether public (anonymous) access to read objects in the bucket is enabled. |
|
list |
boolean Specifies whether public (anonymous) access to the list of objects in the bucket is enabled. |
|
configRead |
boolean Specifies whether public (anonymous) access to read CORS, |
CorsRule
A CORS rule resource.
For details about the concept, see documentation.
|
Field |
Description |
|
id |
string ID of the CORS rule. |
|
allowedMethods[] |
enum (Method) List of HTTP methods allowed by the CORS rule. The number of elements must be greater than 0.
|
|
allowedHeaders[] |
string List of HTTP headers allowed by the CORS rule. |
|
allowedOrigins[] |
string List of request origins allowed by the CORS rule. The number of elements must be greater than 0. |
|
exposeHeaders[] |
string List of headers contained in responses to CORS requests that can be accessed by applications. |
|
maxAgeSeconds |
string (int64) Time in seconds that a client can cache the response to a CORS-preflight request as identified by the |
WebsiteSettings
|
Field |
Description |
|
index |
string Key of the index page object that is returned when a response is made to the root of the website. |
|
error |
string Key of the error page object that is returned when an error occurs. |
|
redirectAllRequests |
Configuration for redirecting all requests sent to the website. |
|
routingRules[] |
List of redirect rules. |
Scheme
A configuration resource for redirecting all requests sent to the website.
|
Field |
Description |
|
protocol |
enum (Protocol) Scheme of the redirect URI.
|
|
hostname |
string Hostname of the redirect URI. |
RoutingRule
List of redirect rules.
|
Field |
Description |
|
condition |
Redirect condition. |
|
redirect |
Redirect instructions. |
Condition
|
Field |
Description |
|
httpErrorCodeReturnedEquals |
string HTTP status code (number only) that must match for the redirect to apply. |
|
keyPrefixEquals |
string Prefix of the object key from which requests are redirected. |
Redirect
|
Field |
Description |
|
hostname |
string Hostname of the redirect URI. |
|
httpRedirectCode |
string HTTP status code of the redirect response. Value must match the regular expression |
|
protocol |
enum (Protocol) Scheme of the redirect URI.
|
|
replaceKeyPrefixWith |
string Substitution for the prefix of the object key specified in Condition.keyPrefixEquals. |
|
replaceKeyWith |
string New object key. |
LifecycleRule
An object lifecycle rule resource for the bucket.
For details about the concept, see documentation.
|
Field |
Description |
|
id |
string ID of the rule. Provided by the client or generated at creation time. |
|
enabled |
boolean Indicates whether the rule is in effect. |
|
filter |
Filter that identifies the objects to which the rule applies. |
|
expiration |
Expiration rule. |
|
transitions[] |
List of transition rules. |
|
abortIncompleteMultipartUpload |
Configuration for aborting incomplete multipart uploads. |
|
noncurrentExpiration |
Expiration rule for non-current versions of objects in a bucket with versioning enabled (Bucket.versioning is |
|
noncurrentTransitions[] |
List of transition rules for non-current versions of objects in a bucket with versioning enabled |
|
noncurrentDeleteMarkers |
Expiration rule for non-current delete markers of an objects in a bucket with versioning |
RuleFilter
|
Field |
Description |
|
prefix |
string Key prefix that the object must have in order for the rule to apply. |
|
objectSizeGreaterThan |
string (int64) Size that the object must be greater. |
|
objectSizeLessThan |
string (int64) Size that the object must be less t. |
|
tag |
Tags that the object's tag set must have for the rule to apply. |
|
andOperator |
Apply a logical AND to all of the predicates configured inside the And operator. |
Tag
|
Field |
Description |
|
key |
string Key of the bucket tag. |
|
value |
string Value of the bucket tag. |
And
|
Field |
Description |
|
prefix |
string Key prefix that the object must have in order for the rule to apply. |
|
objectSizeGreaterThan |
string (int64) Size that the object must be greater. |
|
objectSizeLessThan |
string (int64) Size that the object must be less than. |
|
tag[] |
Tags that the object's tag set must have for the rule to apply. |
Expiration
|
Field |
Description |
|
date |
string (date-time) Specific date of object expiration. String in RFC3339 To work with values in this field, use the APIs described in the |
|
days |
string (int64) Time period, in number of days from the creation or modification of the object, after which an object expires. |
|
expiredObjectDeleteMarker |
boolean Indicates whether a delete marker of an object with no non-current versions (referred to as an expired object |
Transition
List of transition rules.
The transition of an object is described as follows.
For the unversioned bucket (Bucket.versioning is VERSIONING_DISABLED), the object is transitioned to the
specified storage class.
For the bucket with versioning enabled (Bucket.versioning is VERSIONING_ENABLED) or suspended
(VERSIONING_SUSPENDED), the current version of the object is transitioned to the specified storage class.
|
Field |
Description |
|
date |
string (date-time) Specific date of object transition. String in RFC3339 To work with values in this field, use the APIs described in the |
|
days |
string (int64) Time period, in number of days from the creation or modification of the object, after which an object is |
|
storageClass |
string Required field. Storage class to which an object is transitioned from standard storage. |
AfterDays
|
Field |
Description |
|
daysAfterExpiration |
string (int64) Time period, in number of days from the start of the multipart upload, after which the incomplete upload is |
NoncurrentExpiration
|
Field |
Description |
|
noncurrentDays |
string (int64) Time period, in number of days since the version of an object was classified as non-current, after which the |
NoncurrentTransition
List of transition rules for non-current versions of objects in a bucket with versioning enabled
(Bucket.versioning is VERSIONING_ENABLED) or suspended (VERSIONING_SUSPENDED).
At transition, the non-current version of the object is transitioned to the specified storage class.
|
Field |
Description |
|
noncurrentDays |
string (int64) Time period, in number of days since the version of an object was classified as non-current, after which the |
|
storageClass |
string Required field. Storage class to which a non-current version of an object is transitioned from standard storage. |
NoncurrentDeleteMarkers
|
Field |
Description |
|
noncurrentDays |
string (int64) Time period, in number of days since the version of a delete marker was classified as non-current, after which |
ACL
|
Field |
Description |
|
grants[] |
List of permissions granted and the grantees. |
Grant
A grant resource, used to specify the permission granted and the grantee.
|
Field |
Description |
|
permission |
enum (Permission) Required field. Permission granted by the grant.
|
|
grantType |
enum (GrantType) Required field. The grantee type for the grant.
|
|
granteeId |
string ID of the account who is a grantee. Required when the The maximum string length in characters is 50. |
ObjectLock
A resource for Object Lock configuration of a bucket.
For details about the concept, see documentation.
|
Field |
Description |
|
status |
enum (ObjectLockStatus) Status
|
|
defaultRetention |
Default retention |
DefaultRetention
Default lock configuration for added objects
|
Field |
Description |
|
days |
string (int64) Number of days for locking Includes only one of the fields |
|
years |
string (int64) Number of years for locking Includes only one of the fields |
|
mode |
enum (Mode) Mode
|
Encryption
|
Field |
Description |
|
rules[] |
Rules |
EncryptionRule
|
Field |
Description |
|
kmsMasterKeyId |
string KMS master key ID |
|
sseAlgorithm |
string SSE algorithm |
BucketAllowedPrivateEndpoints
|
Field |
Description |
|
enabled |
boolean if true, private endpoints white list check is enabled |
|
privateEndpoints[] |
string white list of private endpoints bucket accessible from |
|
forceCloudConsoleAccess |
boolean if true, cloud console will be able to access a bucket |
Response
HTTP Code: 200 - OK
{
"id": "string",
"description": "string",
"createdAt": "string",
"createdBy": "string",
"modifiedAt": "string",
"done": "boolean",
"metadata": "object",
// Includes only one of the fields `error`, `response`
"error": {
"code": "integer",
"message": "string",
"details": [
"object"
]
},
"response": "object"
// end of the list of possible fields
}
An Operation resource. For more information, see Operation.
|
Field |
Description |
|
id |
string ID of the operation. |
|
description |
string Description of the operation. 0-256 characters long. |
|
createdAt |
string (date-time) Creation timestamp. String in RFC3339 To work with values in this field, use the APIs described in the |
|
createdBy |
string ID of the user or service account who initiated the operation. |
|
modifiedAt |
string (date-time) The time when the Operation resource was last modified. String in RFC3339 To work with values in this field, use the APIs described in the |
|
done |
boolean If the value is |
|
metadata |
object Service-specific metadata associated with the operation. |
|
error |
The error result of the operation in case of failure or cancellation. Includes only one of the fields The operation result. |
|
response |
object The normal response of the operation in case of success. Includes only one of the fields The operation result. |
Status
The error result of the operation in case of failure or cancellation.
|
Field |
Description |
|
code |
integer (int32) Error code. An enum value of google.rpc.Code |
|
message |
string An error message. |
|
details[] |
object A list of messages that carry the error details. |